
/**
 * Spielfeld des Steinfresserspiels
 *
 * @author Johannes Neumeyer
 * @version 1.0
 */
public class Steinzeit extends Ereignisbehandlung
{
    private Stein spielfigur;

    private Steinfresser sf1;
    private Steinfresser sf2;
    private Steinfresser sf3;
    private Steinfresser sf4;
    private Steinfresser sf5;
    private Steinfresser sf6;
    private Steinfresser sf7;
    private Steinfresser sf8;

    /**
     * Legt das Spielfeld und die Objekte an
     */
    public Steinzeit()
    {
        super();        

        spielfigur = new Stein();

        // Gegner erstellen
        sf1 = new Steinfresser();
        sf2 = new Steinfresser();
        sf3 = new Steinfresser();
        sf4 = new Steinfresser();
        sf5 = new Steinfresser();
        sf6 = new Steinfresser();
        sf7 = new Steinfresser();
        sf8 = new Steinfresser();

        // Alle Gegner sollen ihre (zufällige) Startposition einnehmen
        sf1.StartpositionEinnehmen();
        sf2.StartpositionEinnehmen();
        sf3.StartpositionEinnehmen();
        sf4.StartpositionEinnehmen();
        sf5.StartpositionEinnehmen();
        sf6.StartpositionEinnehmen();
        sf7.StartpositionEinnehmen();
        sf8.StartpositionEinnehmen();

        TaktdauerSetzen(100);
        Starten();
    }

    /**
     * Überschriebene Methode von Ereignisbehandlung,
     * die automatisch bei jedem Taktschlag aufgerufen wird
     */
    @Override void TaktImpulsAusführen ()
    {
        // Bei jedem Taktschlag sollen sich alle Gegner weiterbewegen
        sf1.Bewegen();
        sf2.Bewegen();
        sf3.Bewegen();
        sf4.Bewegen();
        sf5.Bewegen();
        sf6.Bewegen();
        sf7.Bewegen();
        sf8.Bewegen();

        // Nach jedem Taktschlag muss geprüft worden, ob man gewonnen oder verloren hat
        GewonnenVerlorenPrüfen();
    }

    /**
     * Prüft, ob das Spiel gewonnen oder verloren wurde
     * und erstellt einen entsprechenden Text
     */
    private void GewonnenVerlorenPrüfen()
    {
        // Gewonnen prüfen
        if (spielfigur.XPositionGeben() > 800)        
        {
            Anhalten();
            Text gewonnen = new Text();
            gewonnen.TextSetzen("Gewonnen!");
            gewonnen.PositionSetzen(300, 250);
            gewonnen.FarbeSetzen("grün");
            gewonnen.TextGrößeSetzen(40);
        }
        // Verloren prüfen
        if (spielfigur.Berührt())
        {
            Anhalten();
            Text verloren = new Text();
            verloren.TextSetzen("Verloren!");
            verloren.PositionSetzen(300, 250);
            verloren.FarbeSetzen("rot");
            verloren.TextGrößeSetzen(40);
        }
    }
}
