
/**
 * Darstellung einer Lampe
 *
 * @author Johannes Neumeyer
 * @version 1.0
 */
class LampenSymbol
{
    private Rechteck kabel;
    private Dreieck schirm;
    private Kreis birne;

    /**
     * Baut das Symbol auf
     * @param x x-Koordinate
     * @param y y-Koordinate
     */
    LampenSymbol (int x, int y)
    {
        kabel = new Rechteck();
        kabel.PositionSetzen(x, y);
        kabel.GrößeSetzen(1, 30);
        kabel.FarbeSetzen("schwarz");
        birne = new Kreis();
        birne.RadiusSetzen(10);
        birne.PositionSetzen(x, y + 55);
        birne.FarbeSetzen("weiß");
        schirm = new Dreieck();
        schirm.GrößeSetzen(50, 25);
        schirm.PositionSetzen(x, y + 30);
        schirm.FarbeSetzen("grau");

    }

    /**
     * Meldet den neuen Zustand an das Symbol
     * @param an die Lampe ist eingeschaltet
     */
    void ÄnderungMelden(boolean an)
    {
        if (an)
        {
            birne.FarbeSetzen("gelb");
        }
        else
        {
            birne.FarbeSetzen("weiß");
        }
    }
}
